import es

dm = es.import_addon('dm')
delay = dm.delay


class Revivor:
    def __init__(self):
        self.reset()
        
    def reset(self):
        self.t = []
        self.ct = []
        
    def player_death(self, userid, attacker):
        team = es.getplayerteam(userid)
        
        revive = False
        if team == 2:
            self.t.append(userid)
        else:
            self.ct.append(userid)
        
        revive = self.getRevive(5-team)
        if revive:
            dm.respawn(revive)
            dm.msg('%s #defaultrevived #lightgreen%s'%(es.getplayername(attacker), es.getplayername(revive)))
            
    def getRevive(self, team):
        if team == 2:
            if self.t:
                revive = self.t.pop(0)
                if es.getuserid(revive):
                    return revive
                else:
                    return self.getRevive(team)
            else:
                return None
                
        if team == 3:
            if self.ct:
                revive = self.ct.pop(0)
                if es.getuserid(revive):
                    return revive
                else:
                    return self.getRevive(team)
            else:
                return None
                
revive = Revivor()

def load():
    for i in es.getUseridList():
        if es.getplayerteam(i) in (2,3):
            if not dm.isAlive(i):
                es.server.queuecmd('mp_restartgame 2')
                return

def player_death(ev):
    revive.player_death(ev['userid'], ev['attacker'])
    
def round_end(ev):
    revive.reset()